#! /usr/local/bin/apl --script
 ⍝ ********************************************************************
 ⍝   $Id: $
 ⍝ $desc: Workspace to test the document object model $
 ⍝ ********************************************************************

)copy dom

∇xml←dom∆test∆hello docName;rootElm;headElm;bodyElm;elm;doc;curNode;childNodes;Hello
  ⍝ Function to build a hello world html page.
  xml←docName dom∆createDocument 'html'
  childNodes←dom∆node∆children xml
  rootElm←dom∆document∆rootElement xml
  headElm←(doc←dom∆node∆ownerDocument xml) dom∆createElement 'head'
  curNode←doc dom∆createElement 'title'
  Hello←doc dom∆createTextNode 'Hello World!'
  curNode←curNode dom∆node∆appendChild Hello
  headElm←headElm dom∆node∆appendChild curNode
  rootElm←rootElm dom∆node∆appendChild headElm
  curNode←(doc dom∆createElement 'h1') dom∆node∆appendChild Hello
  bodyElm←(doc dom∆createElement 'body') dom∆node∆appendChild curNode
  rootElm←rootElm dom∆node∆appendChild bodyElm
  xml←xml dom∆document∆setRootElement rootElm
∇

∇xml←dom∆test∆hello2 doc;rootElm;headElm;bodyElm;contentElm;curNode
  xml←doc dom∆createDocument 'html'
  rootElm ← dom∆document∆rootElement xml
  headElm ← doc dom∆createElement 'head'
  curNode ← doc dom∆createElement 'title'
  curNode ← curNode dom∆node∆appendChild doc dom∆createTextNode 'Hello World II'
  headElm ← headElm dom∆node∆appendChild curNode
  rootElm ← rootElm dom∆node∆appendChild headElm
  bodyElm ← doc dom∆createElement 'body'
  curNode← (doc dom∆createElement 'h1') dom∆node∆appendChild doc dom∆createTextNode 'Hello'
  bodyElm ← bodyElm dom∆node∆appendChild curNode
  curNode ← doc dom∆createElement 'p'
  curNode ← curNode dom∆node∆setAttribute 'class' 'special'
  curNode ← curNode dom∆node∆setAttribute 'id' '001'
  curNode ← curNode dom∆node∆appendChild 'doc' dom∆createTextNode 'And now more content than ever.'
  bodyElm ← bodyElm dom∆node∆appendChild curNode
  rootElm ← rootElm dom∆node∆appendChild bodyElm
  xml←xml dom∆document∆setRootElement rootElm
∇


